<template>
  <div class="col-12">
    <!-- ERROR MESSAGE -->
    <div class="row">
      <div class="col-10 offset-1">
        <div class="alert alert-danger w-100" role="alert" v-if="error">
          {{ error }}
        </div>
      </div>
    </div>

    <!-- UPLOAD -->
    <div class="row mb-3">
      <div class="col-1 my-auto pr-0 text-right" @click="toggleUpload()">
          <span class="arrow text-primary" v-if="!uploadVisible">
            <i class="material-icons text-dark">keyboard_arrow_down</i>
          </span>
          <span class="arrow text-primary" v-else>
            <i class="material-icons text-dark">keyboard_arrow_up</i>
          </span>
      </div>
      <div class="col-10 py-2 text-left">
        <h3 class="heading" @click="toggleUpload()">{{ $t('message.metadata.upload')}}</h3>
        <div class="description text-muted" @click="toggleUpload()">{{ $t('message.metadata.pageDescriptionUpload') }}</div>
      </div>
      <div class="col-10 offset-1 mt-5" v-if="uploadVisible">
        <!-- LIST OF UPLOADED DISTRIBUTIONS -->
        <div class="mb-5" v-for="(distribution, i) in distributions" :key="`distribution${i}`">
          <div class="mb-2 align-baseline">
           <strong>{{ distribution.title }} {{ has(distribution, 'format') ? `(${distribution.format})` : ''}}</strong>
          </div>
          <!-- SUCCESS / ERROR ALERT -->
          <div v-if="distribution.file.uploadSuccess" class="row mt-2">
            <div class="col-12">
              <div class="alert mb-0 py-3" role="alert" :class="{ 'alert-success': distribution.file.uploadSuccess, 'alert-danger': !distribution.file.uploadSuccess}">
                <div class="d-inline-block text-truncate" style="width:90%">
                  <samp :key="distribution.file.fileName" v-if="has(distribution.file, 'fileName')">{{ distribution.file.fileName }}</samp>
                </div>
                <i class="material-icons ml-3 align-baseline float-right">{{ distribution.file.uploadSuccess ? 'check_circle_outline' : 'error_outline' }}</i>
              </div>
            </div>
          </div>
          <!-- CHOOSE FILE & LOADING SPINNER -->
          <div v-else class="row mt-2">
            <div class="col-4 input-group">
              <label class="btn btn-default btn-outline-primary btn-lg mb-0 mr-5 py-3 choose-file">
                {{ $t('message.metadata.chooseFile') }} ...
                <input id="" class="d-none" type="file" :name="distribution.id" v-on:change="handleFileUpload($event.target.name, $event.target.files, distribution)">
              </label>
            </div>
            <div v-if="distribution.file.uploadProcessing" class="col-8">
              <div class="loading-spinner mx-auto mt-3 mb-3"></div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import { mapActions, mapGetters } from 'vuex';
  import { has } from 'lodash';
  import { getTranslationFor } from '../../utils/helpers';

  export default {
    name: 'Upload',
    dependencies: ['uploadService'],
    components: {},
    data() {
      return {
        error: '',
        uploadVisible: true,
        distributions: [],
      };
    },
    props: {},
    computed: {
      ...mapGetters('auth', [
        'securityAuth',
        'getRTPToken',
      ]),
      ...mapGetters('upload', [
        'getValidate',
        'getAPIUploadData',
      ]),
      query() {
        if (typeof this.$route.query.catalog === 'string') return { catalog: this.$route.query.catalog, locale: this.$route.query.locale };
        return { locale: this.$route.query.locale };
      },
    },
    methods: {
      ...mapActions('upload', [
        'setStep',
        'setValidate',
        'addApiUploadData',
      ]),
      has,
      getTranslationFor,
      toggleUpload() {
        this.uploadVisible = !this.uploadVisible;
      },
      /* eslint-disable */
      async handleFileUpload(fieldName, fileList, distribution) {
        this.$Progress.start();
        // Display File Name / Response Status and start the loading spinner
        distribution.file.fileName = fileList[0].name;
        distribution.file.uploadSuccess = false;
        distribution.file.uploadProcessing = true;
        const formData = new FormData();
        formData.append('fname', fileList[0]);
        try {
          const rtpToken = await this.$keycloak.getRtpToken();
          if (rtpToken) {
            const response = await this.uploadService.uploadDistribution(distribution.upload_url, rtpToken.data.access_token, formData);
            this.$Progress.finish();
            // TODO: Finish Loading Spinner
            distribution.file.uploadProcessing = false;
            // Update Response Status
            distribution.file.uploadSuccess = response.status === 200;
          } else {
            this.$Progress.fail();
            // TODO: Finish Loading Spinner
            distribution.file.uploadProcessing = false;
          }
        } catch (err) {
          this.$Progress.fail();
          // TODO: Finish Loading Spinner
          distribution.file.uploadProcessing = false;
        }
      },
      loadDataFromLocalStorage() {
        // Read distribution attributes from local storage
        if (localStorage.getItem('apiUploadData')) {
          this.distributions = JSON.parse(localStorage.getItem('apiUploadData')).distributions;
        }
      },
      next() {
        this.$Progress.start();
        // TODO: Validate File Upload?
        // ...
        // Add apiUploadData to store
        this.addApiUploadData(this.distributions);
        // Navigate to Step 4
        this.$Progress.finish();
        this.setStep(4);
        this.$router.push({ name: 'UploadPageReview', query: this.query, params: this.$route.params });
      },
    },
    watch: {
      getValidate: {
        handler(validate) {
          if (validate) {
            // Call next function
            this.next();
            // Reset Validate State
            this.setValidate(false);
          }
        },
      },
      // Watch on all distribution attributes to store them into local storage on change
      apiUploadData: {
        handler(newApiUploadData) {
          localStorage.setItem('apiUploadData', JSON.stringify(newApiUploadData));
        },
        deep: true,
      },
      distributions: {
        handler(newApiUploadData) {
          this.addApiUploadData({distributions: this.distributions});
        },
        deep: true,
      },
    },
    mounted() {
      this.loadDataFromLocalStorage();
    },
  };
</script>

<style lang="scss" scoped>
  @import '../../styles/bootstrap_theme';
  @import '../../styles/utils/css-animations';

  .heading, .description, .arrow {
    cursor: pointer;
  }

  .choose-file, .alert {
    line-height: 1;
    font-size: 1rem;
  }
  
  .input-group-text {
    background-color: transparent;
    border: 0;
  }
</style>
